diff a/src/hotspot/share/oops/arrayKlass.cpp b/src/hotspot/share/oops/arrayKlass.cpp
--- a/src/hotspot/share/oops/arrayKlass.cpp
+++ b/src/hotspot/share/oops/arrayKlass.cpp
@@ -303,5 +303,12 @@
 void ArrayKlass::oop_verify_on(oop obj, outputStream* st) {
   guarantee(obj->is_array(), "must be array");
   arrayOop a = arrayOop(obj);
   guarantee(a->length() >= 0, "array with negative length?");
 }
+
+int ArrayKlass::hash_offset_in_bytes(oop obj) const {
+  assert(UseCompactObjectHeaders, "only with compact i-hash");
+  arrayOop ary = arrayOop(obj);
+  BasicType type = element_type();
+  return ary->base_offset_in_bytes(type) + (ary->length() << log2_element_size());
+}
